% Neszveda DXCVH0
% M2 exercises

% 1. Elements of control loop
GC=tf(0.9,1)
GA=tf(13.8,[1 13.8])
GP=tf(12.8,[1 17.3 45.3 18.5])
GT=tf(36.7,[1 36.7])

% GPF(s) 
GPF=GA*GP*GT  % It is the result
%                             6483
%--------------------------------------------------------------
%s^5 + 67.8 s^4 + 1425 s^3 + 1.107e004 s^2 + 2.388e004 s + 9370

% G0(s)
%G0=GC*GPF

% Gyr(s)
%Gyr=feedback(GC*GA*GP,GT)   % Result
%                         159 s + 5834
%---------------------------------------------------------------
%s^5 + 67.8 s^4 + 1425 s^3 + 1.107e004 s^2 + 2.388e004 s + 1.52e004

% 2. Stability examination from Gyr
%pole(Gyr)
%-36.7092          
% -14.0952 + 1.2582i
% -14.0952 - 1.2582i
%  -1.6375          
%  -1.2631          
% All poles have negative real part, so the system is stable.

% 3. Stability examination from G0
% bode(G0) % saved as probem2bode
% there isnot gain-crossover frequency and so we have phase margin We have gain
% margin. We have both so the system is stable.
% Note: right mouse click, characteristic, All Stability Margins

% 4. Gains values, whiches belong to the given phase shift.
bode(GPF)  % saved as probeM2K
% Note: First we are looking for the frequency at the given phase shift,
% then at this frequency determine the required gain.
%K1=10^(14.3/20) = 5.2
%K2=10^(21.2/20) = 11.5

% 5.
% poles of GPF(s)
% pole(GPF)
%T1=1/36.7000
%T2=1/14.2020
%T3=1/13.8000
%T4=1/2.5962
%T5=1/0.5017
% Tsim=5*(T1+T2+T3+T4+T5) = 12 sec
% Tsample=Tsim/600 = 0.02sec
% filled modell is saved as probemodell witk K1 gain

% 6. Quality parameters
% with K1
% plot(tout,y) % saved as probeM2K1
% Note: limits of tollerance band are counted on the "Command Window"
% 0.796 and 0.765


% with K2 Note: The previous values of y are overwritten
% plot(tout,y)  % saved as probeM2K2
% Note: limits of tollerance band are counted on the "Command Window"
% 0.91 and 0.87

% The steady-state error less, but the overshoot and settling time will be
% increasing





